// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package memberships

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// MembershipsClient is the client API for Memberships service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type MembershipsClient interface {
	// CreateMembership creates a new membership.
	CreateMembership(ctx context.Context, in *CreateMembershipRequest, opts ...grpc.CallOption) (*CreateMembershipResponse, error)
	// DestroyMembership deletes the membership with the provided ID. THIS REALLY DELETES THE MEMBERSHIP USE UpdateMemebership to end it.
	DestroyMembership(ctx context.Context, in *DestroyMembershipRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// UpdateMembership updates the membership with the provided ID.
	UpdateMembership(ctx context.Context, in *UpdateMembershipRequest, opts ...grpc.CallOption) (*UpdateMembershipResponse, error)
	// ListMemberships returns a list of memberships that match the filter.
	ListMemberships(ctx context.Context, in *ListMembershipsRequest, opts ...grpc.CallOption) (*ListMembershipsResponse, error)
	// SetLock un/locks the database. This is to be able to prevent any changes to the memberships while having a MV.
	SetLock(ctx context.Context, in *SetLockRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// BatchUpdateMemberships updates many memberships at once.
	BatchUpdateMemberships(ctx context.Context, in *BatchUpdateMembershipsRequest, opts ...grpc.CallOption) (*BatchUpdateMembershipsResponse, error)
	// CreateGeneralAssembly creates a new general assembly.
	CreateGeneralAssembly(ctx context.Context, in *CreateGeneralAssemblyRequest, opts ...grpc.CallOption) (*CreateGeneralAssemblyResponse, error)
	// ListGeneralAssemblies returns a list of all general assemblies.
	ListGeneralAssemblies(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ListGeneralAssembliesResponse, error)
	// AddGroup creates a new group.
	AddGroup(ctx context.Context, in *AddGroupRequest, opts ...grpc.CallOption) (*AddGroupResponse, error)
	// UpdateGroup updates a group.
	UpdateGroup(ctx context.Context, in *UpdateGroupRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// AddGroupRole creates a new group role.
	AddGroupRole(ctx context.Context, in *AddGroupRoleRequest, opts ...grpc.CallOption) (*AddGroupRoleResponse, error)
	// UpdateGroupRole updates a group role.
	UpdateGroupRole(ctx context.Context, in *UpdateGroupRoleRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// ListGroups returns a list of groups that match the filter.
	ListGroups(ctx context.Context, in *ListGroupsRequest, opts ...grpc.CallOption) (*ListGroupsResponse, error)
	// ListGroupRoles returns a list of group roles that match the filter.
	ListGroupRoles(ctx context.Context, in *ListGroupRolesRequest, opts ...grpc.CallOption) (*ListGroupRolesResponse, error)
	// AddExOfficio adds an exofficio src dst relationsship.
	AddExOfficio(ctx context.Context, in *AddExOfficioRequest, opts ...grpc.CallOption) (*AddExOfficioResponse, error)
	// UpdateExOfficio updates an exofficio src dst relationsship.
	UpdateExOfficio(ctx context.Context, in *UpdateExOfficioRequest, opts ...grpc.CallOption) (*UpdateExOfficioResponse, error)
	// ListExOfficios returns a list of exofficio src dst relationsships that match the filter.
	ListExOfficios(ctx context.Context, in *ListExOfficiosRequest, opts ...grpc.CallOption) (*ListExOfficiosResponse, error)
}

type membershipsClient struct {
	cc grpc.ClientConnInterface
}

func NewMembershipsClient(cc grpc.ClientConnInterface) MembershipsClient {
	return &membershipsClient{cc}
}

func (c *membershipsClient) CreateMembership(ctx context.Context, in *CreateMembershipRequest, opts ...grpc.CallOption) (*CreateMembershipResponse, error) {
	out := new(CreateMembershipResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/CreateMembership", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) DestroyMembership(ctx context.Context, in *DestroyMembershipRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/DestroyMembership", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) UpdateMembership(ctx context.Context, in *UpdateMembershipRequest, opts ...grpc.CallOption) (*UpdateMembershipResponse, error) {
	out := new(UpdateMembershipResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/UpdateMembership", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) ListMemberships(ctx context.Context, in *ListMembershipsRequest, opts ...grpc.CallOption) (*ListMembershipsResponse, error) {
	out := new(ListMembershipsResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/ListMemberships", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) SetLock(ctx context.Context, in *SetLockRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/SetLock", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) BatchUpdateMemberships(ctx context.Context, in *BatchUpdateMembershipsRequest, opts ...grpc.CallOption) (*BatchUpdateMembershipsResponse, error) {
	out := new(BatchUpdateMembershipsResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/BatchUpdateMemberships", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) CreateGeneralAssembly(ctx context.Context, in *CreateGeneralAssemblyRequest, opts ...grpc.CallOption) (*CreateGeneralAssemblyResponse, error) {
	out := new(CreateGeneralAssemblyResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/CreateGeneralAssembly", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) ListGeneralAssemblies(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ListGeneralAssembliesResponse, error) {
	out := new(ListGeneralAssembliesResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/ListGeneralAssemblies", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) AddGroup(ctx context.Context, in *AddGroupRequest, opts ...grpc.CallOption) (*AddGroupResponse, error) {
	out := new(AddGroupResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/AddGroup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) UpdateGroup(ctx context.Context, in *UpdateGroupRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/UpdateGroup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) AddGroupRole(ctx context.Context, in *AddGroupRoleRequest, opts ...grpc.CallOption) (*AddGroupRoleResponse, error) {
	out := new(AddGroupRoleResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/AddGroupRole", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) UpdateGroupRole(ctx context.Context, in *UpdateGroupRoleRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/UpdateGroupRole", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) ListGroups(ctx context.Context, in *ListGroupsRequest, opts ...grpc.CallOption) (*ListGroupsResponse, error) {
	out := new(ListGroupsResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/ListGroups", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) ListGroupRoles(ctx context.Context, in *ListGroupRolesRequest, opts ...grpc.CallOption) (*ListGroupRolesResponse, error) {
	out := new(ListGroupRolesResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/ListGroupRoles", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) AddExOfficio(ctx context.Context, in *AddExOfficioRequest, opts ...grpc.CallOption) (*AddExOfficioResponse, error) {
	out := new(AddExOfficioResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/AddExOfficio", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) UpdateExOfficio(ctx context.Context, in *UpdateExOfficioRequest, opts ...grpc.CallOption) (*UpdateExOfficioResponse, error) {
	out := new(UpdateExOfficioResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/UpdateExOfficio", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *membershipsClient) ListExOfficios(ctx context.Context, in *ListExOfficiosRequest, opts ...grpc.CallOption) (*ListExOfficiosResponse, error) {
	out := new(ListExOfficiosResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.memberships.Memberships/ListExOfficios", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// MembershipsServer is the server API for Memberships service.
// All implementations must embed UnimplementedMembershipsServer
// for forward compatibility
type MembershipsServer interface {
	// CreateMembership creates a new membership.
	CreateMembership(context.Context, *CreateMembershipRequest) (*CreateMembershipResponse, error)
	// DestroyMembership deletes the membership with the provided ID. THIS REALLY DELETES THE MEMBERSHIP USE UpdateMemebership to end it.
	DestroyMembership(context.Context, *DestroyMembershipRequest) (*emptypb.Empty, error)
	// UpdateMembership updates the membership with the provided ID.
	UpdateMembership(context.Context, *UpdateMembershipRequest) (*UpdateMembershipResponse, error)
	// ListMemberships returns a list of memberships that match the filter.
	ListMemberships(context.Context, *ListMembershipsRequest) (*ListMembershipsResponse, error)
	// SetLock un/locks the database. This is to be able to prevent any changes to the memberships while having a MV.
	SetLock(context.Context, *SetLockRequest) (*emptypb.Empty, error)
	// BatchUpdateMemberships updates many memberships at once.
	BatchUpdateMemberships(context.Context, *BatchUpdateMembershipsRequest) (*BatchUpdateMembershipsResponse, error)
	// CreateGeneralAssembly creates a new general assembly.
	CreateGeneralAssembly(context.Context, *CreateGeneralAssemblyRequest) (*CreateGeneralAssemblyResponse, error)
	// ListGeneralAssemblies returns a list of all general assemblies.
	ListGeneralAssemblies(context.Context, *emptypb.Empty) (*ListGeneralAssembliesResponse, error)
	// AddGroup creates a new group.
	AddGroup(context.Context, *AddGroupRequest) (*AddGroupResponse, error)
	// UpdateGroup updates a group.
	UpdateGroup(context.Context, *UpdateGroupRequest) (*emptypb.Empty, error)
	// AddGroupRole creates a new group role.
	AddGroupRole(context.Context, *AddGroupRoleRequest) (*AddGroupRoleResponse, error)
	// UpdateGroupRole updates a group role.
	UpdateGroupRole(context.Context, *UpdateGroupRoleRequest) (*emptypb.Empty, error)
	// ListGroups returns a list of groups that match the filter.
	ListGroups(context.Context, *ListGroupsRequest) (*ListGroupsResponse, error)
	// ListGroupRoles returns a list of group roles that match the filter.
	ListGroupRoles(context.Context, *ListGroupRolesRequest) (*ListGroupRolesResponse, error)
	// AddExOfficio adds an exofficio src dst relationsship.
	AddExOfficio(context.Context, *AddExOfficioRequest) (*AddExOfficioResponse, error)
	// UpdateExOfficio updates an exofficio src dst relationsship.
	UpdateExOfficio(context.Context, *UpdateExOfficioRequest) (*UpdateExOfficioResponse, error)
	// ListExOfficios returns a list of exofficio src dst relationsships that match the filter.
	ListExOfficios(context.Context, *ListExOfficiosRequest) (*ListExOfficiosResponse, error)
	mustEmbedUnimplementedMembershipsServer()
}

// UnimplementedMembershipsServer must be embedded to have forward compatible implementations.
type UnimplementedMembershipsServer struct {
}

func (UnimplementedMembershipsServer) CreateMembership(context.Context, *CreateMembershipRequest) (*CreateMembershipResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateMembership not implemented")
}
func (UnimplementedMembershipsServer) DestroyMembership(context.Context, *DestroyMembershipRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DestroyMembership not implemented")
}
func (UnimplementedMembershipsServer) UpdateMembership(context.Context, *UpdateMembershipRequest) (*UpdateMembershipResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateMembership not implemented")
}
func (UnimplementedMembershipsServer) ListMemberships(context.Context, *ListMembershipsRequest) (*ListMembershipsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListMemberships not implemented")
}
func (UnimplementedMembershipsServer) SetLock(context.Context, *SetLockRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetLock not implemented")
}
func (UnimplementedMembershipsServer) BatchUpdateMemberships(context.Context, *BatchUpdateMembershipsRequest) (*BatchUpdateMembershipsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BatchUpdateMemberships not implemented")
}
func (UnimplementedMembershipsServer) CreateGeneralAssembly(context.Context, *CreateGeneralAssemblyRequest) (*CreateGeneralAssemblyResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateGeneralAssembly not implemented")
}
func (UnimplementedMembershipsServer) ListGeneralAssemblies(context.Context, *emptypb.Empty) (*ListGeneralAssembliesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListGeneralAssemblies not implemented")
}
func (UnimplementedMembershipsServer) AddGroup(context.Context, *AddGroupRequest) (*AddGroupResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddGroup not implemented")
}
func (UnimplementedMembershipsServer) UpdateGroup(context.Context, *UpdateGroupRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateGroup not implemented")
}
func (UnimplementedMembershipsServer) AddGroupRole(context.Context, *AddGroupRoleRequest) (*AddGroupRoleResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddGroupRole not implemented")
}
func (UnimplementedMembershipsServer) UpdateGroupRole(context.Context, *UpdateGroupRoleRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateGroupRole not implemented")
}
func (UnimplementedMembershipsServer) ListGroups(context.Context, *ListGroupsRequest) (*ListGroupsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListGroups not implemented")
}
func (UnimplementedMembershipsServer) ListGroupRoles(context.Context, *ListGroupRolesRequest) (*ListGroupRolesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListGroupRoles not implemented")
}
func (UnimplementedMembershipsServer) AddExOfficio(context.Context, *AddExOfficioRequest) (*AddExOfficioResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddExOfficio not implemented")
}
func (UnimplementedMembershipsServer) UpdateExOfficio(context.Context, *UpdateExOfficioRequest) (*UpdateExOfficioResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateExOfficio not implemented")
}
func (UnimplementedMembershipsServer) ListExOfficios(context.Context, *ListExOfficiosRequest) (*ListExOfficiosResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListExOfficios not implemented")
}
func (UnimplementedMembershipsServer) mustEmbedUnimplementedMembershipsServer() {}

// UnsafeMembershipsServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to MembershipsServer will
// result in compilation errors.
type UnsafeMembershipsServer interface {
	mustEmbedUnimplementedMembershipsServer()
}

func RegisterMembershipsServer(s grpc.ServiceRegistrar, srv MembershipsServer) {
	s.RegisterService(&Memberships_ServiceDesc, srv)
}

func _Memberships_CreateMembership_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateMembershipRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).CreateMembership(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/CreateMembership",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).CreateMembership(ctx, req.(*CreateMembershipRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_DestroyMembership_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DestroyMembershipRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).DestroyMembership(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/DestroyMembership",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).DestroyMembership(ctx, req.(*DestroyMembershipRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_UpdateMembership_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateMembershipRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).UpdateMembership(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/UpdateMembership",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).UpdateMembership(ctx, req.(*UpdateMembershipRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_ListMemberships_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListMembershipsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).ListMemberships(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/ListMemberships",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).ListMemberships(ctx, req.(*ListMembershipsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_SetLock_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SetLockRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).SetLock(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/SetLock",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).SetLock(ctx, req.(*SetLockRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_BatchUpdateMemberships_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BatchUpdateMembershipsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).BatchUpdateMemberships(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/BatchUpdateMemberships",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).BatchUpdateMemberships(ctx, req.(*BatchUpdateMembershipsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_CreateGeneralAssembly_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateGeneralAssemblyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).CreateGeneralAssembly(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/CreateGeneralAssembly",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).CreateGeneralAssembly(ctx, req.(*CreateGeneralAssemblyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_ListGeneralAssemblies_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).ListGeneralAssemblies(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/ListGeneralAssemblies",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).ListGeneralAssemblies(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_AddGroup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AddGroupRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).AddGroup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/AddGroup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).AddGroup(ctx, req.(*AddGroupRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_UpdateGroup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateGroupRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).UpdateGroup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/UpdateGroup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).UpdateGroup(ctx, req.(*UpdateGroupRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_AddGroupRole_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AddGroupRoleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).AddGroupRole(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/AddGroupRole",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).AddGroupRole(ctx, req.(*AddGroupRoleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_UpdateGroupRole_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateGroupRoleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).UpdateGroupRole(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/UpdateGroupRole",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).UpdateGroupRole(ctx, req.(*UpdateGroupRoleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_ListGroups_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListGroupsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).ListGroups(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/ListGroups",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).ListGroups(ctx, req.(*ListGroupsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_ListGroupRoles_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListGroupRolesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).ListGroupRoles(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/ListGroupRoles",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).ListGroupRoles(ctx, req.(*ListGroupRolesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_AddExOfficio_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AddExOfficioRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).AddExOfficio(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/AddExOfficio",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).AddExOfficio(ctx, req.(*AddExOfficioRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_UpdateExOfficio_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateExOfficioRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).UpdateExOfficio(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/UpdateExOfficio",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).UpdateExOfficio(ctx, req.(*UpdateExOfficioRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Memberships_ListExOfficios_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListExOfficiosRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MembershipsServer).ListExOfficios(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.memberships.Memberships/ListExOfficios",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MembershipsServer).ListExOfficios(ctx, req.(*ListExOfficiosRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Memberships_ServiceDesc is the grpc.ServiceDesc for Memberships service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Memberships_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.vis.memberships.Memberships",
	HandlerType: (*MembershipsServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateMembership",
			Handler:    _Memberships_CreateMembership_Handler,
		},
		{
			MethodName: "DestroyMembership",
			Handler:    _Memberships_DestroyMembership_Handler,
		},
		{
			MethodName: "UpdateMembership",
			Handler:    _Memberships_UpdateMembership_Handler,
		},
		{
			MethodName: "ListMemberships",
			Handler:    _Memberships_ListMemberships_Handler,
		},
		{
			MethodName: "SetLock",
			Handler:    _Memberships_SetLock_Handler,
		},
		{
			MethodName: "BatchUpdateMemberships",
			Handler:    _Memberships_BatchUpdateMemberships_Handler,
		},
		{
			MethodName: "CreateGeneralAssembly",
			Handler:    _Memberships_CreateGeneralAssembly_Handler,
		},
		{
			MethodName: "ListGeneralAssemblies",
			Handler:    _Memberships_ListGeneralAssemblies_Handler,
		},
		{
			MethodName: "AddGroup",
			Handler:    _Memberships_AddGroup_Handler,
		},
		{
			MethodName: "UpdateGroup",
			Handler:    _Memberships_UpdateGroup_Handler,
		},
		{
			MethodName: "AddGroupRole",
			Handler:    _Memberships_AddGroupRole_Handler,
		},
		{
			MethodName: "UpdateGroupRole",
			Handler:    _Memberships_UpdateGroupRole_Handler,
		},
		{
			MethodName: "ListGroups",
			Handler:    _Memberships_ListGroups_Handler,
		},
		{
			MethodName: "ListGroupRoles",
			Handler:    _Memberships_ListGroupRoles_Handler,
		},
		{
			MethodName: "AddExOfficio",
			Handler:    _Memberships_AddExOfficio_Handler,
		},
		{
			MethodName: "UpdateExOfficio",
			Handler:    _Memberships_UpdateExOfficio_Handler,
		},
		{
			MethodName: "ListExOfficios",
			Handler:    _Memberships_ListExOfficios_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/vis/memberships/memberships.proto",
}
